// Define snake properties;
#define snakeMaxLength 52
int snake[snakeMaxLength];
byte snakeHead;
byte snakeLength;
#define NUMAPPLES 5
int apples[NUMAPPLES];

void snake_loop()
{

  int newitemDirX=0;
  int newitemDirY=0;
  int ret = nunchuck_get_data();
  if (!ret) {
    delay(500);
    nunchuck_init();
  } else {
    int joyY=nunchuck_joyy();
    int joyX=nunchuck_joyx();
    if (joyX<64) newitemDirX=-1;
    if (joyX>172) newitemDirX=+1;
    if (joyY<64) newitemDirY=+1;
    if (joyY>172) newitemDirY=-1;

    if (newitemDirX || newitemDirY) {
      if (!((itemDirX == -newitemDirX) && (itemDirY == -newitemDirY))) {
        itemDirX=newitemDirX;
        itemDirY=newitemDirY;
      }
    }

    snake_move();
    tuneStep=(tuneStep+1) % 2;
    tone(speakerPin,500+(points % levelMax)*50+(100*tuneStep),speed*2);
    delay(speed);
  }
}

void snake_add_apple(byte applenum)
{
  Serial.println("Add apple");
  byte aX = random(gameMinX+1,gameMaxX);
  byte aY = random(gameMinY+1,gameMaxY);
  if (dmd.getPixel(aX,aY)>0) {
    snake_add_apple(applenum);
    return;
  }

  apples[applenum]=(aX<<8) + aY;
  dmd.writePixel(aX,aY,WHITE);
}

void snake_setup_snake(byte x, byte y)
{
  for (byte i=0;i<snakeMaxLength;i++) {
    snake[i]=0xFFFF; // marker for unused spot
  }
  snakeLength=1;
  snakeHead=snakeLength-1;
  snake[snakeHead] = (x<<8) + y;
  dmd.writePixel(highByte(snake[snakeHead]),lowByte(snake[snakeHead]),7);
  itemDirX=random(3)-1;
  itemDirY=random(3)-1;
  if ((itemDirX==0) && (itemDirY==0)) itemDirX=1;
}

void snake_move ()
{
  byte oldsnakeHead = snakeHead;
  byte oldsnakeTail=(snakeMaxLength+snakeHead-snakeLength) % snakeMaxLength;
  snakeHead=(snakeHead+1) % snakeMaxLength;

  byte snakeTail=(oldsnakeTail +1) % snakeMaxLength;

  byte x = (highByte(snake[oldsnakeHead]) + itemDirX) % (gameMaxX+1);
  if ((x < gameMinX) || (x > 50)) x = gameMaxX;

  byte y = (lowByte(snake[oldsnakeHead]) + itemDirY) % (gameMaxY+1);
  if ((y < gameMinY) || (y > 50)) y = gameMaxY;

  snake[snakeHead] = (x<<8) + y;
  // Check if hitting an apple
  for (byte i=0;i<NUMAPPLES;i++) {
    if (snake[snakeHead]==apples[i]){
      points++;
      dmd.writePixel(highByte(snake[snakeHead]),lowByte(snake[snakeHead]),0);
      Serial.println("hit apple");
      if ((points % levelMax) == 0) {
        //next level
        level++;
        speed = 32-((points % levelMax)/2)-(2*level);
        display_score();
        snake_setup_level();
        return;
      }
      speed = (32-((points % levelMax)/2)-(2*level))*4;
      snakeLength=min(snakeLength+2,snakeMaxLength);
      snake_add_apple(i);
      update_scorebar(scoreY);
    }
  }

  boolean hit = false;
  // Check if hitting self
  for (byte i=0; i < snakeMaxLength; i++) {
    if (i != snakeHead) {
      if (snake[i] == snake[snakeHead]) {
        hit=true;
      }
    }
  }
  
  // Check if hitting wall
  byte col=dmd.getPixel((unsigned int)highByte(snake[snakeHead]),(unsigned int)lowByte(snake[snakeHead]));
  Serial.println(col);
  if (dmd.getPixel(highByte(snake[snakeHead]),lowByte(snake[snakeHead]))>0) {
    hit=true;
  }

  if (hit) {
    Serial.println("hit something");
    display_gameover();
    display_score();
    snake_setup_game();
  } else {
    // Set the head/tail values
    dmd.writePixel(highByte(snake[oldsnakeTail]),lowByte(snake[oldsnakeTail]),BLACK);
    snake[oldsnakeTail] = 0xFFFF;
    dmd.writePixel(highByte(snake[snakeTail]),lowByte(snake[snakeTail]),WHITE);
    dmd.writePixel(highByte(snake[snakeHead]),lowByte(snake[snakeHead]),WHITE);
  }
}

void snake_setup_board()
{
  Serial.println("Setup board");

  byte numLevels = 4;
  byte myLevel=((level-1) % numLevels) + 1;
  if (myLevel == 1) {
    // Four outside walls
    add_wall(gameMinX,gameMinY,gameMaxX,gameMinY);
    add_wall(gameMaxX,gameMinY,gameMaxX,gameMaxY);
    add_wall(gameMinX,gameMinY,gameMinX,gameMaxY);
    add_wall(gameMinX,gameMaxY,gameMaxX,gameMaxY);
    snake_setup_snake(gameCentreX, gameCentreY);
  } 
  else if (myLevel == 2) {
    // Four outside walls plus internal bar
    add_wall(gameMinX,gameMinY,gameMaxX,gameMinY);
    add_wall(gameMaxX,gameMinY,gameMaxX,gameMaxY);
    add_wall(gameMinX,gameMinY,gameMinX,gameMaxY);
    add_wall(gameMinX,gameMaxY,gameMaxX,gameMaxY);
    add_wall((gameMaxX/3), gameCentreY, (gameMaxX/3*2), gameCentreY);
    snake_setup_snake(gameCentreX, (gameMaxY-gameMinY)/3);
  } 
  else if (myLevel == 3) {
    // Four outside walls with gaps plus internal cross
    add_wall(gameMinX,gameMinY,gameCentreX-3,gameMinY);
    add_wall(gameCentreX+3,gameMinY,gameMaxX,gameMinY);
    add_wall(gameMaxX,gameMinY,gameMaxX,gameCentreY-3);
    add_wall(gameMaxX,gameCentreY+3,gameMaxX,gameMaxY);
    add_wall(gameMinX,gameMinY,gameMinX,gameCentreY-3);
    add_wall(gameMinX,gameCentreY+3,gameMinX,gameMaxY);
    add_wall(gameMinX,gameMaxY,gameCentreX-3,gameMaxY);
    add_wall(gameCentreX+3,gameMaxY,gameMaxX,gameMaxY);
    add_wall((gameMaxX/3), gameCentreY, (gameMaxX/3*2), gameCentreY);
    add_wall(gameCentreX, gameMaxY/3, gameCentreX, gameMaxY/3*2);
    snake_setup_snake(gameCentreX, gameCentreY-5);
  } 
  else if (myLevel == 4) {
    // Two walls splitting board into quarters
    add_wall(gameCentreX, gameMinY, gameCentreX, gameMaxX);
    add_wall(gameMinX, gameCentreY, gameMaxX, gameCentreY);
    snake_setup_snake(gameMinX+2, gameMinY+2);
  }
}

void snake_setup_game()
{
  if (gameType==NONE) return;
  Serial.println("Snake");
  points=0;
  level=1;
  dmd.clearScreen(0);
  write_predef(LEVEL,2,5,WHITE);
  write_number(level,12,19,WHITE);
  int oldlevel = level;
  nunchuck_wait();
  boolean selected=false;
  while (!selected) {
    int ret = nunchuck_get_data();
    if (!ret) {
      delay(500);
      nunchuck_init();
    } else {
      if (nunchuck_zbutton()) selected=true;
      if (nunchuck_cbutton()) {
          gameType=NONE;
          return;
      }
      if (nunchuck_joyy()<64 || nunchuck_joyx()<64) level--;
      if (nunchuck_joyy()>172 || nunchuck_joyx()>172) level++;
      if (level==0) level=1;
      if (level != oldlevel) {
        dmd.clearScreen(0);
        write_predef(LEVEL,2,5,7);
        write_number(level,12,19,7);
        delay(100);
        oldlevel=level;
        nunchuck_wait();
      }
    }
    delay(1);
  }
  snake_setup_level();
}

void snake_setup_level()
{
  dmd.clearScreen(0);

  // NUMAPPLES initial apples
  for (byte i=0; i<NUMAPPLES; i++) {
    snake_add_apple(i);
  }
  speed = (32-((points % levelMax)/2)-(2*level))*4;
  snake_setup_board();  
}
